* Standard defines and routines for the TI99/4A Home Computer
* to use with the Editor/Assembler module.
*
	TITL	'EA UTILITIES IN LOW MEMORY'

	IDT	'ASMUP'

*
* To be assembled with XA99 which 
* Can be loaded in LOMEM with the
* .O >2000 option with L99
*
* Give the NAME# a value > 0 if you need them:
*=============================================================
GPRDT#	EQU	0	* 1: Generate predefined REF/DEF table
SCAN#	EQU	1	* 1: Need the SCAN symbol
XMLLK#	EQU	1	* 1: Need the XMLLNK function
KSCAN#	EQU	1	* 1: Need the KSCAN  function
VSBW#	EQU	1	* 1: Need the VSBW   function
VMBW#	EQU	1	* 1: Need the VMBW   function
VSBR#	EQU	1	* 1: Need the VSBR   function
VMBR#	EQU	1	* 1: Need the VMBR   function
VWTR#	EQU	1	* 1: Need the VWTR   function
DSRLK#	EQU	1	* 1: Need the DSRLNK function
LOADR#	EQU	1	* 1: Need the LOADER function
GPLLK#	EQU	1	* 1: Need the GPLLK  function
NAMLK#	EQU	1	* 1: Need the NAMLNK function
CIF#	EQU	1	* 1: Need the CIF    function
*=============================================================
*
VDPH#	EQU	VSBW#+VMBW#+VSBR#+VMBR#

	DEF	UTLTAB,PAD,GPLWS,SOUND
	DEF	VDPRD,VDPSTA,VDPWD,VDPWA
	DEF	SPCHRD,SPCHWT
	DEF	GRMRA,GRMRD,GRMWD,GRMWA

#if SCAN#
	DEF	SCAN
#endif
#if XMLLK#
	DEF	XMLLNK
#endif
#if KSCAN#
	DEF	KSCAN
#endif
#if VSBW#
	DEF	VSBW
#endif
#if VMBW#
	DEF	VMBW
#endif
#if VSBR#
	DEF	VSBR
#endif
#if VMBR#
	DEF	VMBR
#endif
#if VWTR#
	DEF	VWTR
#endif
#if DSRLK#
	DEF	DSRLNK
#endif
#if LOADR#
	DEF	LOADER
#endif
#if GPLLK#
	DEF	GPLLNK
#endif


* TI99/4A predefined addresses
*
PAD	EQU	>8300
GPLWS	EQU	>83E0
SOUND	EQU	>8400
VDPRD	EQU	>8800
VDPSTA	EQU	>8802
VDPWD	EQU	>8C00
VDPWA	EQU	>8C02
SPCHRD	EQU	>9000
SPCHWT	EQU	>9400
GRMRD	EQU	>9800
GRMRA	EQU	>9802
GRMWD	EQU	>9C00
GRMWA	EQU	>9C02
SCAN	EQU	>000E

*Register MSB/LSB offsets
*
MR00   EQU  0
LR00   EQU  1
MR01   EQU  2
LR01   EQU  3
MR02   EQU  4
LR02   EQU  5
MR03   EQU  6
LR03   EQU  7
MR04   EQU  8
LR04   EQU  9
MR05   EQU  10
LR05   EQU  11
MR06   EQU  12
LR06   EQU  13
MR07   EQU  14
LR07   EQU  15
MR08   EQU  16
LR08   EQU  17
MR09   EQU  18
LR09   EQU  19
MR10   EQU  20
LR10   EQU  21
MR11   EQU  22
LR11   EQU  23
MR12   EQU  24
LR12   EQU  25
MR13   EQU  26
LR13   EQU  27
MR14   EQU  28
LR14   EQU  29
MR15   EQU  30
LR15   EQU  31


* START OF LOMEM
*
*	AORG	>2000

	DATA	>A55A
#if NAMLK#
	DATA	NAMLNK	2128	Start address name link routine    (XML >21)
#else
	DATA	>0000	2128	Start address name link routine    (XML >21)
#endif
#if LOADR#
	DATA	BLOADR	2398	Start address loader called by GPL (XML >22)
#else
	DATA	>0000	2398	Start address loader called by GPL (XML >22)
#endif
#if CIF#
	DATA	CIF	225A	Start address of CIF (int ->flt)   (XML >23)
#else
	DATA	>0000	225A	Start address of CIF (int ->flt)   (XML >23)
#endif

	BSS	26
*	AORG	>2022

UTLTAB	EQU $

LPADDR	DATA	>0000	2022	Start address of loaded program
FSTHI	DATA	>A000	2024	First free address in himem
LSTHI	DATA	>FFD7	2026	Last  free address in himem
FSTLOW	DATA	LOFIFR	2028	First free address in lomem (2676)
LSTLOW	DATA	LOLAFR	202A	Last  free address in lomem (3F38 start REF/DEF table)

CHKSAV	DATA	>0000	202C	Checksum
FLGPTR	DATA	>0000	202E	Pointer to status in PAB (VDP)
SVGPRT	DATA	>0000	2030	GPL return address
SAVCRU	DATA	>0000	2032	CRU adres of peripheral
SAVENT	DATA	>0000	2034	DSR subprogram entry address
SAVLEN	DATA	>0000	2036	DSR device or sub program name length
SAVPAB	DATA	>0000	2038	DSR device name addres in PAB in VDP
SAVVER	DATA	>0000	203A	DSR version number
LOADRB	BSS	80	203C	LOADER record buffer
DSRLNB	BSS	8	208C	DSRLNK name buffer
UTILWS	BSS	6	2094	Utility workspace (overlaps DSRLWS)
DSRLWS	BSS	32	209A	DSRLNK workspace
USERWS	BSS	32	20BA	User workspace
LOADWS	BSS	32	20DA	LOADER workspace
DC100	DATA	100	20FA	Decimal constant 100
BC20	BYTE	>20	20FC	Byte constant >20
BC00	BYTE	>00	20FD	Byte constant >00
BC2E	TEXT	'.'	20FE	Byte constant decimal point (ASCII code)
BCAA	BYTE	>AA	20FF	Byte constant AA for check DSR ROM available

* Function Vectors
*
#if GPLLK#
GPLLNK	DATA	UTILWS,GPLLK$	2100 2094 21C4
#endif
#if XMLLK#
XMLLNK	DATA	UTILWS,XMLLK$   2104 2094 2196
#endif
#if KSCAN#
KSCAN	DATA	UTILWS,KSCAN$   2108 2094 21DE
#endif
#if VSBW#
VSBW	DATA	UTILWS,VSBW$    210C 2094 21F4
#endif
#if VMBW#
VMBW	DATA	UTILWS,VMBW$    2110 2094 2200
#endif
#if VSBR#
VSBR	DATA	UTILWS,VSBR$    2114 2094 220E
#endif
#if VMBR#
VMBR	DATA	UTILWS,VMBR$    2118 2094 221A
#endif
#if VWTR#
VWTR	DATA	UTILWS,VWTR$    211C 2094 2228
#endif
#if DSRLK#
DSRLNK	DATA	DSRLWS,DSRLK$   2120 209A 22B2
#endif
#if LOADR#
LOADER	DATA	LOADWS,LOADR$   2124 20DA 23BA
#endif

* Functions

* NAMLNK (XML >21)	2128
#if NAMLK#
NAMLNK	MOV	R11,@SVGPRT		Save GPL environment
	MOVB	@>8349,R1		Get ...
	COC 	@BC20,R1		... bit set?
	JEQ 	L218A			Yes!
	MOV 	@>8350,R0		Get ...
	JEQ 	L215E			Not ...!
	BL 	@L2646			Check for unresolved references
	JMP	L217E			There are unresolved references: Quit

L2142	CI	R1,>3F38		Start of default REF/DEF table?
	JEQ	L217A			Yes, not found!
	MOV	R1,R0
	LI	R2,>834A		Function name to find
	C	*R0+,*R2+		Char 1 and 2 equal?
	JNE	L2174			No!
	C	*R0+,*R2+		Char 3 and 4 equal?
	JNE	L2174			No!
	C	*R0+,*R2+		Char 5 and 6 equal?
	JNE	L2174			No!
	MOV	*R0,@UTLTAB		Save function address
L215E	LWPI	USERWS
	MOV	@UTLTAB,R0		Get function address
	JEQ	L217A			Unresolved or not defined!
	BL	*R0			Call assembler function
	LWPI	GPLWS			Restore GPL environment
	MOV	@SVGPRT,R11
	B	*R11

L2174	AI	R1,8			Next name
	JMP	L2142			Continue!

L217A	LI	R0,>0F00		Return to GPL
L217E	MOVB	R0,@>8322
	LWPI	GPLWS
	B	@>00CE

L218A	SZCB	@BC20,@>8349		Set EQ bit
	LWPI	UTILWS
	RTWP
#endif

* XMLLNK  (>2196)
#if XMLLK#
XMLLK$	MOV	*R14+,@GPLWS+MR01	Function number to R1
	LWPI	GPLWS
	MOV	R11,@UTILWS+MR11	Save R11
	MOV	R1,R2
	CI	R1,>8000		Function is start address?
	JH	XMLGO			No!
	SRL	R1,12			Table number
	SLA	R1,01
	SLA	R2,04			Function number
	SRL	R2,11
	A	@>0CFA(R1),R2		Get function address offset
	MOV	*R2,R2			Get function address
XMLGO	BL	*R2			Call function
	LWPI	UTILWS
	MOV	R11,@GPLWS+MR11		Restore R11
	RTWP
#endif


* GPLLNK
#if GPLLK#
GPLLK$	MOVB	@>8373,R1		Get offset on GPL subroutine stack
	SRL	R1,08			Move to LSByte
	MOV	*R14+,@>8304(R1)	Copy GPL routine number to stack
	SOCB	@BC20,@>8349		Set bit ?
	LWPI	GPLWS
	MOV	@SVGPRT,R11		Get return address
	B	*R11
#endif

* KSCAN
#if KSCAN#
KSCAN$	LWPI	GPLWS
	MOV	R11,@UTILWS+MR11	20AA
	BL	@SCAN
	LWPI	UTILWS
	MOV	R11,@GPLWS+MR11		83F6
	RTWP
#endif

* VSBW
#if VSBW#
VSBW$	BL	@VDPW
	MOVB	@2(R13),@VDPWD
	RTWP
#endif

* VMBW
#if VMBW#
VMBW$	BL	@VDPW
VMBW$1	MOVB	*R1+,@VDPWD
	DEC	R2
	JNE	VMBW$1
	RTWP
#endif

* VSBR
#if VSBR#
VSBR$	BL	@VDPR			2240
	MOVB	@VDPRD,@2(R13)
	RTWP
#endif

* VMBR
#if VMBR#
VMBR$	BL	@VDPR
VMBR$1	MOVB	@VDPRD,*R1+
	DEC	R2
	JNE	VMBR$1
	RTWP
#endif

* VWTR
#if VWTR#
VWTR$	MOV	*R13,R1
	MOVB	@1(R13),@VDPWA
	ORI	R1,>8000
	MOVB	R1,@VDPWA
	RTWP
#endif


* VDP R/W helper
#if VDPH#
VDPW	LI	R1,>4000
	JMP	VDP$1
VDPR	CLR	R1
VDP$1	MOV	*R13,R2
	MOVB	@UTILWS+LR02,@VDPWA	@>2099 ,@>8C02
	SOC	R1,R2
	MOVB	R2,@VDPWA
	MOV	@2(R13),R1
	MOV	@4(R13),R2
	RT
#endif


* CIF (XML >23)	>225A
#if CIF#
CIF	LI	R4,>834A		Get integer value in FAC
	MOV	*R4,R0
	MOV	R4,R6			Clear FAC
	CLR	*R6+
	CLR	*R6+
	MOV	R0,R5			INT=0?
	JEQ	L22B0			Yes!
	ABS	R0
	LI	R3,>0040		100^(R3 - 64)
	CLR	*R6+			Clear some more of FAC
	CLR	*R6
	CI	R0,100			INT<100?
	JL	L22A0			Yes!
	CI	R0,10000		INT<...?
	JL	L2290			Yes!
	INC	R3			Increment power of 100
	MOV	R0,R1
	CLR	R0
	DIV	@DC100,R0		Divide by 100
	MOVB	@GPLWS+LR01,@3(R4)	Third byte of FLT
L2290	INC	R3			Increment power of 100
	MOV	R0,R1
	CLR	R0
	DIV	@DC100,R0		Divide by 100
	MOVB	@GPLWS+LR01,@2(R4)	Second byte of FLT
L22A0	MOVB	@GPLWS+LR00,@1(R4)	First byte of FLT
	MOVB	@GPLWS+LR03,*R4		Power of 100 of FLT
	INV	R5			Was INT a positive number ?
	JLT	L22B0			Yes!
	NEG	*R4			No, make FLT also negative!
L22B0	B	*R11
#endif

* DSRLNK
#if DSRLK#
DSRLK$	MOV	*R14+,R5		Routine number
	SZCB	@BC20,R15		Reset EQ bit
	MOV	@>8356,R0		Pab pointer to name
	MOV	R0,R9			Pab pointer
	AI	R9,-8
	BLWP	@VSBR			Get name length
	MOVB	R1,R3			Store
	SRL	R3,8			To LSByte
	SETO	R4			Devicename length
	LI	R2,DSRLNB		Name buffer
DSRL#0	INC	R0			Get next char of name
	INC	R4
	C	R4,R3			Last character of name?
	JEQ	DSRL#1			Yes!
	BLWP	@VSBR			Get next character
	MOVB	R1,*R2+			Add to name buffer
	CB	R1,@BC2E		Is it '.'?
	JNE	DSRL#0			No!
DSRL#1	MOV	R4,R4			Name length=0?
	JEQ	DSR#DN			Yes!
	CI	R4,7			Name length>7?
	JGT	DSR#DN			Yes!

	CLR	@>83D0			Last used CRU address
	MOV	R4,@>8354		Save name length
	MOV	R4,@SAVLEN
	INC	R4			Adjust beyond '.'
	A	R4,@>8356		Position after name
	MOV	@>8356,@SAVPAB

DSR#SR	LWPI	GPLWS
	CLR	R1			Version found
	LI	R12,>0F00		First device CRU address
DSR#NR	MOV	R12,R12
	JEQ	DSR#ON
	SBZ	0			Device off
DSR#ON	AI	R12,>0100		Next device
	CLR	@>83D0
	CI	R12,>2000		End of devices?
	JEQ	DSR#NO			Yes!

	MOV	R12,@>83D0		Save cru
	SBO	0			Device on
	LI	R2,>4000		Start of DSR rom
	CB	*R2,@BCAA		Id >AA?
	JNE	DSR#NR			No!
	A	@DSRLWS+MR05,R2
	JMP	DSR#4

DSR#3	MOV	@>83D2,R2		Continue
	SBO	0			Device on
DSR#4	MOV	*R2,R2			Address=0?
	JEQ	DSR#NR			Yes!
	MOV	R2,@>83D2		Store table entry
	INCT	R2			Start address
	MOV	*R2+,R9
	MOVB	@>8355,R5		Get devicename length
	JEQ	DSR#6			=0, dont do match
	CB	R5,*R2+			Length match?
	JNE	DSR#3			No!

	SRL	R5,8
	LI	R6,DSRLNB		Device name
DSR#5	CB	*R6+,*R2+		Are names equal?
	JNE	DSR#3			No!
	DEC	R5			More?
	JNE	DSR#5			Yes!
DSR#6	INC	R1			Next version
	MOV	R1,@SAVVER		Save version
	MOV	R9,@SAVENT		Save entry
	MOV	R12,@SAVCRU		Save cru
	BL	*R9			Execute
	JMP	DSR#3			Wrong version
	SBZ	0			Device off
	LWPI	DSRLWS
	MOV	R9,R0			Flagbyte in PAB
	BLWP	@VSBR
	SRL	R1,13
	JNE	DSR#IO			IO error!
	RTWP

DSR#NO	LWPI	DSRLWS
DSR#DN	CLR	R1			Devicename error
DSR#IO	SWPB	R1			IO error
	MOVB	R1,*R13
	SOCB	@BC20,R15		Set EQ bit
	RTWP
#endif

* LOADER (CALL LOAD())
#if LOADR#
BLOADR	MOV       R11,@SVGPRT		Save GROM pointer
	LWPI      USERWS
	BLWP      @LOADER		Load assembler code
	LWPI      GPLWS
	JEQ       L23B0			Error!
	MOV       @SVGPRT,R11		Restore GROM pointer
	B         *R11			Return
L23B0	MOVB      @USERWS,@>8322 	Error code (R0 USERWS)
	B         @>00CE  		?

LOADR$	CLR       @LPADDR		Clear start address
	SZCB      @BC20,R15		Reset EQ bit
	MOV       @>8356,R0		Addres of PAB in VDP
	BLWP      @DSRLNK		Open file
	DATA      8
	JEQ       L2432			Error!
	AI        R0,-9			Address of PAB in VDP
	LI        R1,>0200		Opcode for read
	BLWP      @VSBW			Write to pab
	INC       R0			Address of PAB Flag
	MOV       R0,@FLGPTR		Save pointer
	MOV       @FSTHI,R7		Free address in HIMEM
	MOV       R7,R5
	CLR       R12			Uncompressed(0) or Compressed(1) code
	BL        @L25E0 		Read a record
	CI        R3,>0001		Compressed code?
	JNE       L243A			No!
	INC       R12			Compressed code
	CLR       R3			...
	JMP       L243E

* Read next TAG until EOF
* R0 record data
* R1 record buffer address
* R2 remaining bytes in record buffer
* R3 last read byte from record
* R4 Miscellaneous
* R5 relocation base
* R7 load address
L23F8	CI        R3,>0046		End of record (tag F)?
	JNE       L243A			No!
TAGF EQU $			*** End of record
	CLR       R2			Finished

* Read next TAG until EOF then close file
*
TAG8 EQU $			*** Ignored record checksum	
L2400	BL        @L262E  		Read next TAG (and record)
	CI        R3,>003A		End of file (tag :) ?
	JNE       L23F8			No!
	MOV       @FLGPTR,R0		Get PAB status address
	DEC       R0
	LI        R1,>0100		Close file opcode
	BLWP      @VSBW			Write to PAB
	BL        @L25E0  		Close file
	MOV       @UTLTAB,R0		Auto start program?
	JEQ       L2430			No!
	BL        @L2646  		Check for unresolved references
	JMP       L2432			There are unresolved references!
	MOV       R14,@MR11(R13)	Save return address of loader
	MOV       @UTLTAB,R14		Start address loaded code
L2430	RTWP 				Execute!

L2432	MOVB      R0,*R13		File IO result code
	SOCB      @BC20,R15		Set EQ bit
	RTWP

L243A	BL        @L25C2		Convert ASCII to Binary
L243E	CLR       R4
	MOVB      @TAGTAB(R3),R4	Get TAG entry point
	SRL       R4,7			To LSByte * 2
	MOV       R8,@CHKSAV		Save checksum
	BL        @L2594		Get DATA
	B         @L23F8(R4)		Call TAG function

TAG0 EQU $			*** Module ID
	INC       R0			Module length is even
	ANDI      R0,>FFFE
	MOV       @FSTHI,R4		Load in HIMEM
	A         R0,R4
	JOC       L2470			Beyond 64Kb, Does not fit!
	C         R4,@LSTHI		Beyond last free HIMEM address?
	JH        L2470			Yes, does not fit!
	MOV       @FSTHI,R5		Get relocation base in HIMEM
	MOV       R4,@FSTHI		New relocation base in HIMEM
	JMP       L2484
	
L2470	MOV       @FSTLOW,R4		Load in LOMEM
	A         R0,R4
	C         R4,@LSTLOW		Beyond last free LOMEM address?
	JHE       L2494			Yes, does not fit!
	MOV       @FSTLOW,R5		Get relocation base in LOMEM
	MOV       R4,@FSTLOW		New relocation base in LOMEM
L2484	MOV       R5,R7			Relocation base is also data load address

TAGI EQU $			*** Program segment ID (ignored)
	LI        R9,8			Skip module ID name / Program segment ID name
L248A	BL        @L262E		Get next BYTE
	DEC       R9			More to skip?
	JNE       L248A			Yes!
	JMP       L2400			Next TAG!

L2494	LI        R0,>0800		IO Error 8: Memory overflow
	JMP       L2432			Quit!

TAG2 EQU $			*** Relative entry address
	A         R5,R0			Add relocation base
TAG1 EQU $			*** Absolute entry address
	MOV       R0,@LPADDR		Save module start address		
	JMP       L2400			Next TAG!
	
TAG7 EQU $			*** Record checksum	
	A         R0,@CHKSAV		Add to calculated checksum
	JEQ       L2400			Result is 0: Is Ok, Next TAG!
	LI        R0,>0B00		IO Error 11: Checksum error
	JMP       L2432			Quit!

TAGA EQU $			*** Relocatable load address
	A         R5,R0			Add relocation base
TAG9 EQU $			*** Absolute load address
	MOV       R0,R7			New load address
	JMP       L2400			Next TAG!
	

TAGC EQU $			*** Relocatable data
	A         R5,R0			Add relocation base
TAGB EQU $			*** Absolute data
	MOVB      R0,*R7+		MSB data to CPU memory
	MOVB      @LOADWS+LR00,*R7+	LSB data to CPU memory
	JMP       L2400			Next TAG!
	
TAG3 EQU $			*** Relocatable external reference
	A         R5,R0			Add relocation base
TAG4 EQU $			*** Absolute external reference
	BL        @L2566		Add to REF/DEF table
	MOV       R0,R0			Entry point is NULL?
	JEQ       L24F4			Yes, first occurence
L24C8	AI        R6,-8			Previous entry
	C         R6,R4			Reached new added entry?
	JH        L24D4			No, check if allready added
	NEG       *R4			Yes, not a DEF found
L24D2	JMP       L2400			Next TAG!


* Solve a REF
*
* Input: R3 New added name entry address
*	 R4 New added name in REF/DEF table
*        R6 A previous added name in REF/DEF table
*
L24D4	C         *R4,*R6		Char 1 and 2 equal?
	JNE       L24C8			No!
	C         @2(R4),@2(R6)		Char 3 and 4 equal?
	JNE       L24C8			No!
	C         @4(R4),@4(R6)		Char 5 and 6 equal?
	JNE       L24C8			No!
	MOV       @6(R6),R3		Get REF address
L24EC	MOV       *R0,R9		Expand list: get previous REF
	MOV       R3,*R0		Link the new
	MOV       R9,R0			More to solve?
	JNE       L24EC			Yes!
L24F4	AI        R4,8			Remove last added name
	MOV       R4,@LSTLOW		Repair last free addres in LOMEM
	JMP       L24D2			Next TAG!

TAG5 EQU $			*** Relocatable external definition
	A         R5,R0			Add relocation base
TAG6 EQU $			*** Absolute external definition
	BL        @L2566		Add to REF/DEF table
L2504	AI        R6,-8			Previous entry
L2508	C         R6,R4			Reached new added entry?
	JEQ       L24D2			Yes, Next TAG!

	MOV       *R6,R10		Get first two chars of name
	JGT       L2512			Positive: DEFINED
	NEG       R10			Negative: UNDEFINED
L2512	C         *R4,R10		Char 1 and 2 equal?
	JNE       L2504			No!
	C         @2(R4),@2(R6)		Char 3 and 4 equal?
	JNE       L2504			No!
	C         @4(R4),@4(R6)		Char 5 and 6 equal?
	JNE       L2504			No!
	MOV       *R6,R10		Get first two chars of name
	JGT       L2556			Positive: DEFINED

	MOV       @6(R6),R3		Get DEF address
L252E	MOV       *R3,R9		Resolve list: Get REF address
	MOV       R0,*R3		Resolve REF
L2532	MOV       R9,R3			Next in list
	JNE       L252E			More to resolve
	MOV       R6,R9			Calculate offset old entry
	S         R4,R9			and new entry
	MOV       R6,R10		Start here
	AI        R10,8			
	MOV       R6,R3			From here
L2542	DECT      R3
	DECT      R10
	MOV       *R3,*R10		Move entry's up
	DECT      R9			More to move?
	JNE       L2542			Yes!
	AI        R4,8			Previous name is removed
	MOV       R4,@LSTLOW		Repair last free address in LOMEM
	JMP       L2508			Continue 
	
L2556	MOV       R4,@2(R13)
	LI        R0,>0C00		Error 12: Unresolved reference
	B         @L2432		Quit
L2562	B         @L2494		Error 8: Memory overflow

* Add a new reference or definition to the REF/DEF table
*
* Input : R0 reference/definition address
* Output: R6 end address of REF/DEF table
*
L2566	MOV       R11,R10		Save return address
	LI        R9,6			REF/DEF name length
	MOV       @LSTLOW,R6		Start address of REF/DEF table
	AI        R6,-8			Reserve space for new name
	MOV       R6,R4			Save
	C         R6,@FSTLOW		Below first free address in LOMEM?
	JL        L2562			Yes, out of memory!
	MOV       R6,@LSTLOW		Updated address REF/DEF table
L2580	BL        @L262E		Get next BYTE
	MOVB      @LOADWS+LR03,*R6+	Copy to REF/DEF table
	DEC       R9			More bytes?
	JNE       L2580			Yes
	MOV       R0,*R6		Add REF/DEF address to table
	LI        R6,>4000		End address of REF/DEF table
	B         *R10			Return

* Get (un)compressed data from record
*
* Input : R1 Record address
*         R2 Number of remaining bytes
*         R8 Updated record checksum
* Output: R0 Data from record
*
L2594	MOV       R11,R10		Save return address
	CLR       R0
	MOV       R12,R12		Compressed?
	JEQ       L25AC			No!
	BL        @L262E		Get next BYTE
	MOVB      @LOADWS+LR03,R0	To MSB of R0
	BL        @L262E		Get next BYTE
	A         R3,R0			To LSB of R0
	B         *R10			Return
*
* Get uncompressed data from record
*
L25AC	LI        R9,4			Number of nibbles to get
L25B0	BL        @L262E		Get next TAG/BYTE
	BL        @L25C2		Convert ASCII to Binary
	SLA       R0,4			Shift nibbles in Ro
	A         R3,R0			To LSNibble of R0
	DEC       R9			More nibbles?
	JNE       L25B0			Yes!
	B         *R10			Return

* Convert ASCII 0-9,A-I to binary
*
* Input : R3 LSByte ASCII value
* Output: R3 LSNibble Binary value 
*
L25C2	AI        R3,-48		Subtract ASCII '0'
	CI        R3,10			Value 0-9?
	JL        L25D6			Yes!
	AI        R3,-7
	CI        R3,25			Value A-I? (this must be CI R3,18)
	JH        L25D8			No, illegal TAG!
L25D6	B         *R11			Ok!

TAGD EQU $			*** Load Bias
TAGE EQU $			*** Undefined
TAGG EQU $			*** Undefined
TAGH EQU $			*** Undefined
L25D8	LI        R0,>0A00		IO error 10: Illegal tag
	B         @>2432		Quit!

* Read record or Close file
*
* Input : PAB opcode set to read (2) or close (1)
* Output: R1 Record address
*         R2 Number of remaining bytes
*         R3 First TAG
*         R8 Updated record checksum
*
L25E0	LWPI      GPLWS
	LI        R0,SAVCRU
	MOV       *R0+,R12		Restore CRU
	MOV       *R0+,R9		Restore DSR entry
	MOV       *R0+,@>8354 		Restore name length
	MOV       *R0+,@>8356 		Restore name address
	MOV       *R0,R1		Restore version
	SBO       0			Device on
	CB        @>4000,@BCAA		DSR available?
	JNE       L263A			No, quit
	BL        *R9			Call DSR function
	JMP       L263A			Error
	SBZ       0			Device off
	LWPI      LOADWS
	MOV       @FLGPTR,R0		FlgPtr of PAB in VDP
	LI        R1,LOADWS+LR00	Start destination LB R0
	LI        R2,4			Number of bytes to read: Read Flg (R0),
	BLWP      @VMBR			Buffer address (R1),  Record length(R2)
	SB        R0,R0			Reset MSB R0
	SRL       R0,5			PAB status is no error?
	JNE       L2640			No, quit!
	SRL       R2,8			Record length to LSB
	MOV       R1,R0			Buffer address in VDP to R0
	LI        R1,LOADRB		Record buffer in CPU ram
	BLWP      @VMBR			Copy record
	CLR       R8			Clear checksum

* Get next BYTE
*
* Input : R1 Record address
*         R2 Number of remaining bytes
*         R8 Updated record checksum
* Output: R3 Next TAG
*         R1,R2,R8 Updated
*
L262E	DEC       R2			More data available?
	JLT       L25E0			No, read next record!
	MOVB      *R1+,R3		Get BYTE
	SRL       R3,8
	A         R3,R8			Update checksum
	B         *R11

L263A	LWPI      LOADWS
	CLR       R0			IO error 0: Device not found
L2640	SWPB      R0
	B         @>2432  		Quit

* Check REF/DEF table for unresolved references
L2646	LI        R1,>3F40		End of current loaded REF/DEF table
L264A	AI        R1,-8			Previous entry
	MOV       *R1,R0		First two characters of name
	JLT       L265C			Negative, thus unresolved!
	C         @LSTLOW,R1		More?
	JNE       L264A			Yes!
	INCT      R11
	B         *R11
L265C	LI        R0,>0D00		Error 13: Unresolved references
	B         *R11

* TAG jump table relative to code at L23F8
* Entry address: L23F8 + 2*OFFSET
*
TAGTAB	BYTE TAG0-L23F8/2	>2D	TAG 0
	BYTE TAG1-L23F8/2	>52	TAG 1
	BYTE TAG2-L23F8/2	>51	TAG 2
	BYTE TAG3-L23F8/2	>63	TAG 3
	BYTE TAG4-L23F8/2	>64	TAG 4
	BYTE TAG5-L23F8/2	>83	TAG 5
	BYTE TAG6-L23F8/2	>84	TAG 6
	BYTE TAG7-L23F8/2	>55	TAG 7
	BYTE TAG8-L23F8/2	>04	TAG 8
	BYTE TAG9-L23F8/2	>5C	TAG 9
	BYTE TAGA-L23F8/2	>5B	TAG A
	BYTE TAGB-L23F8/2	>5F	TAG B
	BYTE TAGC-L23F8/2	>5E	TAG C
	BYTE TAGD-L23F8/2	>F0	TAG D
	BYTE TAGE-L23F8/2	>F0	TAG E
	BYTE TAGF-L23F8/2	>03	TAG F
	BYTE TAGG-L23F8/2	>F0	TAG G
	BYTE TAGH-L23F8/2	>F0	TAG H
	BYTE TAGI-L23F8/2	>47	TAG I
	BYTE >00	EOT
#endif

LOFIFR	EQU	$		First free address in LO memory

* REF/DEF Table
*
#if GPRDT#
*
* Fill predefined REF/DEF table
*
AORG#0	EQU	11*8+>3F38

AORG#X	EQU	SCAN#+XMLLK#+KSCAN#+DSRLK#+LOADR#+GPLLK#
AORG#Y	EQU	VSBW#+VMBW#+VSBR#+VMBR#+VWTR#
AORG#Z	EQU	AORG#X+AORG#Y*8

*LOLAFR	AORG	>3F38		Last free address in LO memory
LOLAFR	EQU	AORG#0-AORG#Z

	AORG	LOLAFR		Last free address in LO memory

	TEXT	'UTLTAB'
	DATA	UTLTAB		>2022
	TEXT	'PAD   '
	DATA	PAD		>8300
	TEXT	'GPLWS '
	DATA	GPLWS		>83E0
	TEXT	'SOUND '
	DATA	SOUND		>8400
	TEXT	'VDPRD '
	DATA	VDPRD		>8800
	TEXT	'VDPSTA'
	DATA	VDPSTA		>8802
	TEXT	'VDPWD '
	DATA	VDPWD		>8C00
	TEXT	'VDPWA '
	DATA	VDPWA		>8C02
	TEXT	'SPCHRD'
	DATA	SPCHRD		>9000
	TEXT	'SPCHWT'
	DATA	SPCHWT		>9400
	TEXT	'GRMRD '
	DATA	GRMRD		>9800
	TEXT	'GRMRA '
	DATA	GRMWA		>9802
	TEXT	'GRMWD '
	DATA	GRMWD		>9C00
	TEXT	'GRMWA '
	DATA	GRMWA		>9C02


#if SCAN#
	TEXT	'SCAN  '
	DATA	SCAN		>000E
#endif
#if XMLLK#
	TEXT	'XMLLNK'
	DATA	XMLLNK		>2104	2094 2196
#endif
#if KSCAN#
	TEXT	'KSCAN '
	DATA	KSCAN		>2108	2094 21DE
#endif
#if VSBW#
	TEXT	'VSBW  '
	DATA	VSBW		>210C	2094 21F4
#endif
#if VMBW#
	TEXT	'VMBW  '
	DATA	VMBW		>2110	2094 2200
#endif
#if VSBR#
	TEXT	'VSBR  '
	DATA	VSBR		>2114	2094 220E
#endif
#if VMBR#
	TEXT	'VMBR  '
	DATA	VMBR		>2118	2094 221A
#endif
#if VWTR#
	TEXT	'VWTR  '
	DATA	VWTR		>211C	2094 2228
#endif
#if DSRLK#
	TEXT	'DSRLNK'
	DATA	DSRLNK		>2120	209A 22B2
#endif
#if LOADR#
	TEXT	'LOADER'
	DATA	LOADER		>2124	20DA 23BA
#endif
#if GPLLK#
	TEXT	'GPLLNK'
	DATA	GPLLNK		>2100	2094 21C4
#endif

#else
* No predefined REF/DEF table
LOLAFR	EQU	>4000
#endif
	END