
 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0001
  0001            * Written by:
  0002            *
  0003            *  Frederik G. Kaal
  0004            *  Goudsbloem 68
  0005            *  3984 CP Odijk
  0006            *  The Netherlands
  0007            *
  0008            * These are the Level 2 routines for file and floppy access 
  0009            * sector level.
  0010            *
  0011            * All routines returns 0 if no error occured and -1 if an er
  0012            * The error code is left in errno. A result of -1 with errno
  0013            * bad device name.
  0014            
  0015            *	TITL 'L2FIO FUNCTIONS 18/10/2004'
  0016            * 09/03/2007 - Moved special ADIFILE() code from L2BUF0
  0017            * to ADIFILE() function because of left pointer in R5
  0018            *
  0020            
  0021            	IDT 'L2FIO'
  0022            
  0023            	DEF READSE,WRITES,FMTDSK,FILES
  0024            	DEF ATTRIB,RENAME,RENDIR,ADIFIL,ADOFIL
  0025            	DEF SETSPA,SETDPA,MKDIR,RMDIR,SETSRC,SETDST
  0026            	DEF PABCOD,CRULST,CRUSRC,CRUDST,THSCRU,LSTCRU
  0027            	DEF GETU#1,GETU#2,GETU#4,GETU#6,L2BUF0,L2BUF2,L2BUF3
  0028            	DEF BUFL2,PABL2,H834C,H834D,H834E,H8350,H8352,SAVEG
  0029            
  0030            	REF ERRNO,CNULL
  0031            	REF GPLWS,VMBW,VSBW,VSBR,VMBR,GRMRA,GRMWA
  0032            
  0033      1600  BUFRW  EQU >1600    Buffer Read/Write
  0034      1700  BUFL2  EQU >1700
  0035      1580  PABL2  EQU >1580
  0036      1590  NAME1  EQU >1590
  0037      15A0  NAME2  EQU >15A0
  0038            
  0039 0000       SAVEG  BSS  2
  0040 0002       PABCOD BSS  2
  0041 0004       PABCD2 BSS  2
  0042 0006       CRUSRC BSS  2
  0043 0008       CRUDST BSS  2
  0044 000A       THSCRU BSS  2
  0045 000C       LSTCRU BSS  2
  0046 000E 1000  FMTCRU DATA >1000,>2000
       0010 2000 
  0047            
  0048 0012   44  P#DSK  BYTE 'D','S','K',0
       0013   53 
       0014   4B 
       0015   00 
  0049 0016   48  P#HDS  BYTE 'H','D','S',0
       0017   44 
       0018   53 
       0019   00 
  0050 001A   57  P#WDS  BYTE 'W','D','S',0
       001B   44 
       001C   53 
       001D   00 

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0002
  0051 001E   53  P#SCS  BYTE 'S','C','S',0
       001F   43 
       0020   53 
       0021   00 
  0052 0022   49  P#IDE  BYTE 'I','D','E',0
       0023   44 
       0024   45 
       0025   00 
  0053 0026   48  P#HDX  BYTE 'H','D','X',0
       0027   44 
       0028   58 
       0029   00 
  0054 002A 0012' DEVNAM DATA P#DSK,P#HDS,P#WDS,P#SCS,P#IDE,P#HDX       * char
       002C 0016'
       002E 001A'
       0030 001E'
       0032 0022'
       0034 0026'
  0055 0036 0110  DEVL2C DATA >0110,>0120,>0120,>0120,>0180,>0190,>0000 * int 
       0038 0120 
       003A 0120 
       003C 0120 
       003E 0180 
       0040 0190 
       0042 0000 
  0056            
  0057      0000  SECRW EQU 0   /* Read Write Sector */
  0058      0001  FORFD EQU 1   /* Format Floppy Disk */
  0059      0002  MODFP EQU 2   /* Modify File Protection */
  0060      0003  RNFIL EQU 3   /* Rename File */
  0061      0004  DIFIL EQU 4   /* Direct Input File */
  0062      0005  DOFIL EQU 5   /* Direct Output File */
  0063      0006  BUFAL EQU 6   /* Buffer Allocation */
  0064      0007  SCPTH EQU 7   /* Set Current Path */
  0065      0008  CRSUB EQU 8   /* Create Subdirectory */
  0066      0009  RMSUB EQU 9   /* Remove Subdirectory */
  0067      000A  RNSUB EQU 10  /* Rename Subdirectory */
  0068            
  0069            * setsrc()  - store src cru addres in crusrc
  0070            *
  0071 0044 C820  SETSRC MOV  @>83D0,@CRUSRC
       0046 83D0 
       0048 0006'
  0072 004A 045D         B   *13
  0073            
  0074            * setdst()  - store dst cru addres in crudst
  0075            *
  0076 004C C820  SETDST MOV @>83D0,@CRUDST
       004E 83D0 
       0050 0008'
  0077 0052 045D         B   *13
  0078            
  0079            * getunit(device) char *device
  0080            * - determine drive number 1..9 or A..Z and
  0081            *   basic level1 routine
  0082            *   returns basic level1 routine code
  0083            *   if error returns -1
  0084            * device:  devicename e.g. "DSK1"
  0085            *

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0003
  0086            *GETUNI BL   @GETU#2
  0087            *       B    *13
  0088            
  0089            * GETU#1-#A - See Getunit
  0090            *
  0091            * Input : R1 address of device name
  0092            * Output: R1 unchanged
  0093            *         R8 result code
  0094            * Uses  : R0, R1, R2, R3, R4, R8
  0095            *
  0096 0054 C06E  GETU#C MOV  @12(14),1
       0056 000C 
  0097 0058 100B         JMP  GETU#1
  0098 005A C06E  GETU#8 MOV  @8(14),1
       005C 0008 
  0099 005E 1008         JMP  GETU#1
  0100 0060 C06E  GETU#6 MOV  @6(14),1
       0062 0006 
  0101 0064 1005         JMP  GETU#1
  0102 0066 C06E  GETU#4 MOV  @4(14),1
       0068 0004 
  0103 006A 1002         JMP  GETU#1
  0104 006C C06E  GETU#2 MOV  @2(14),1
       006E 0002 
  0105 0070 04E0  GETU#1 CLR  @ERRNO
       0072 0000 
  0106            *       CLR  5            pointer sectors  adifile
  0107            *       CLR  6            pointer code adifile
  0108 0074 0202         LI   2,DEVNAM     names
       0076 002A'
  0109 0078 0203         LI   3,DEVL2C     codes
       007A 0036'
  0110 007C C233  GETUN0 MOV  *3+,8        first code
  0111 007E 131C         JEQ  GETUEX       end of tabel
  0112 0080 C101  GETUN1 MOV  1,4          this device
  0113 0082 C032         MOV  *2+,0        next device
  0114 0084 9810  GETUN2 CB   *0,@CNULL    end
       0086 0000 
  0115 0088 1303         JEQ  GETUFN       yes
  0116 008A 9D30         CB   *0+,*4+
  0117 008C 13FB         JEQ  GETUN2
  0118 008E 10F6         JMP  GETUN0       next
  0119 0090 04C2  GETUFN CLR  2
  0120 0092 D094         MOVB *4,2         unit#
  0121 0094 0282         CI   2,'0'*256    0-9	(20200618 for DSK0. on Horizon 
       0096 3000 
  0122 0098 1A0C         JL   GETUER       <1
  0123 009A 0282         CI   2,'9'*256
       009C 3900 
  0124 009E 1206         JLE  GETU19
  0125 00A0 0282         CI   2,'A'*256    A-Z
       00A2 4100 
  0126 00A4 1A06         JL   GETUER       <A
  0127 00A6 0282         CI   2,'Z'*256
       00A8 5A00 
  0128 00AA 1B03         JH   GETUER       >Z
  0129 00AC 0222  GETU19 AI   2,-'0'*256   >1->9 >11->2A
       00AE D000 
  0130 00B0 1001         JMP  GETUAZ

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0004
  0131 00B2 04C8  GETUER CLR  8
  0132 00B4 D802  GETUAZ MOVB 2,@H834C
       00B6 0448'
  0133 00B8 C808  GETUEX MOV  8,@PABCOD
       00BA 0002'
  0134 00BC C808         MOV  8,@PABCD2
       00BE 0004'
  0135 00C0 1301         JEQ  GETUQT      Error
  0136 00C2 045B         RT
  0137 00C4 0708  GETUQT SETO 8           Quit
  0138 00C6 045D         B    *13
  0139            
  0140            * Some SCSI constants
  0141            *
  0142      0000  SE$256 EQU  >00     Sector size 256
  0143      0010  SE$512 EQU  >10     Sector size 512
  0144      0020  SE$124 EQU  >20     Sector size 1024
  0145      0030  SE$248 EQU  >30     Sector size 2048
  0146      0080  BF$CPU EQU  >80     Buf in CPU ram
  0147            
  0148 00C8   01  DN#SID BYTE >01     Device # to SCSI id
  0149 00C9   80  BF#CPU BYTE BF$CPU
  0150 00CA   90  SC#SCS BYTE BF$CPU+SE$512
  0151                   EVEN
  0152            
  0153            * T#SCS - Check if devicename is SCS and
  0154            * set scsi options bits in H834C
  0155            *
  0156 00CC C02E  T#SCS  MOV  @6(14),0    devicename
       00CE 0006 
  0157 00D0 0201         LI   1,P#SCS
       00D2 001E'
  0158 00D4 0709         SETO 9
  0159 00D6 9C70         CB   *0+,*1+
  0160 00D8 1609         JNE  T#SCS#
  0161 00DA 9C70         CB   *0+,*1+
  0162 00DC 1607         JNE  T#SCS#
  0163 00DE 9C70         CB   *0+,*1+
  0164 00E0 1605         JNE  T#SCS#
  0165 00E2 F820         SOCB @SC#SCS,@H834C
       00E4 00CA'
       00E6 0448'
  0166 00E8 0209         LI   9,0         Scsi!
       00EA 0000 
  0167 00EC 045B  T#SCS# RT
  0168            
  0169            * readsector(device, buffer, sector) char *device, *buffer; 
  0170            * read a sector from a device
  0171            * device:  devicenam e.g. "DSK1"
  0172            * buffer:  buffer in CPU ram for data, if buffer addres
  0173            *          is NULL data will be left in VDP ram (not for SCS
  0174            * sector:  sectornumber 32 bits e.g. int[2]
  0175            *
  0176 00EE 06A0  READSE BL   @GETU#6
       00F0 0060'
  0177 00F2 06A0         BL   @T#SCS       Scsi?
       00F4 00CC'
  0178 00F6 1603         JNE  READS1       No!
  0179 00F8 C02E         MOV  @4(14),0     Sector

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0005
       00FA 0004 
  0180 00FC 1002         JMP  READS2
  0181 00FE 0200  READS1 LI   0,BUFRW      VDP sector buffer
       0100 1600 
  0182 0102 C800  READS2 MOV  0,@H834E
       0104 044A'
  0183 0106 C02E         MOV  @2(14),0     Sector #
       0108 0002 
  0184 010A C830         MOV  *0+,@H8352   How
       010C 044E'
  0185 010E C810         MOV  *0,@H8350    Low
       0110 044C'
  0186 0112 0208         LI   8,SECRW      Read/Write sector
       0114 0000 
  0187 0116 0707         SETO 7            Read sector
  0188 0118 06A0         BL   @L2BUF2
       011A 0346'
  0189 011C C249         MOV  9,9          Scsi?
  0190 011E 1309         JEQ  READSX       Yes!
  0191 0120 0200         LI   0,BUFRW      VDP sector buffer
       0122 1600 
  0192 0124 C06E         MOV  @4(14),1     Sector
       0126 0004 
  0193 0128 1304         JEQ  READSX
  0194 012A 0202         LI   2,256        Sector size
       012C 0100 
  0195 012E 0420         BLWP @VMBR
       0130 0000 
  0196 0132 045D  READSX B    *13
  0197            
  0198            * writesector(device, buffer, sector) char *device, buffer; 
  0199            * - write a sector to a device
  0200            * device:  devicenam e.g. "DSK1"
  0201            * buffer:  buffer in CPU ram with data
  0202            * sector:  sectornumber 32 bits e.g. int[2]
  0203            *
  0204 0134 06A0  WRITES BL   @GETU#6
       0136 0060'
  0205 0138 06A0         BL   @T#SCS       Scsi?
       013A 00CC'
  0206 013C 1603         JNE  WRITS1       No!
  0207 013E C02E         MOV  @4(14),0     Sector
       0140 0004 
  0208 0142 1008         JMP  WRITS2
  0209 0144 0200  WRITS1 LI   0,BUFRW      VDP sector buffer
       0146 1600 
  0210 0148 C06E         MOV  @4(14),1     Sector
       014A 0004 
  0211 014C 0202         LI   2,256        Sector size
       014E 0100 
  0212 0150 0420         BLWP @VMBW
       0152 0000 
  0213 0154 C800  WRITS2 MOV  0,@H834E
       0156 044A'
  0214 0158 C02E         MOV  @2(14),0     Sector
       015A 0002 
  0215 015C C830         MOV  *0+,@H8352   How
       015E 044E'
  0216 0160 C810         MOV  *0,@H8350    Low

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0006
       0162 044C'
  0217 0164 0208         LI   8,SECRW      Read/Write sector
       0166 0000 
  0218 0168 04C7         CLR  7            Write
  0219 016A 06A0         BL   @L2BUF2
       016C 0346'
  0220 016E 045D         B    *13
  0221            
  0222            * files(nof) int nof;
  0223            * - allocate bufferspace for number of files
  0224            * nof: number of files 1-16
  0225            * if error returns -1
  0226            *
  0227 0170 C02E  FILES  MOV  @2(14),0
       0172 0002 
  0228 0174 06C0         SWPB 0
  0229 0176 C800         MOV  0,@H834C
       0178 0448'
  0230 017A 04E0         CLR  @PABCOD
       017C 0002'
  0231 017E 04C0         CLR  0
  0232 0180 04C7         CLR  7
  0233 0182 0208         LI   8,>0116      CALL FILES() opcode
       0184 0116 
  0234 0186 1021         JMP  FMT#2        Search all DSR's
  0235            
  0236            * fmtdsk(device, mode, sides, tracks, density, interleave)
  0237            * char *device; int  mode, sides, tracks, density, interleav
  0238            * - format a floppy disk
  0239            *
  0240            * device:  devicenam e.g. "DSK1"
  0241            * mode  :  search mode   0= search all DSR's
  0242            *                       >0= CRUSRC contains CRU address
  0243            * sides :  number of sides 0,1= single 2=double sided
  0244            * tracks:  number of tracks 40 or 80
  0245            * density: disk density 0,1 single density FM  125Kbits/sec
  0246            *                       2   double density MFM 250Kbits/sec
  0247            *                       3   double density MFM 500Kbits/sec
  0248            * interleave: 1..sectors-1
  0249            *             default 4 for single density, 5 for double den
  0250            *
  0251            * returns: @>8350 number of sectors per disk
  0252            *
  0253 0188 06A0  FMTDSK BL   @GETU#C
       018A 0054'
  0254 018C 0208         LI   8,FORFD      Format FD
       018E 0001 
  0255 0190 04C0         CLR  0            Number of sectors
  0256 0192 C800         MOV  0,@>834A
       0194 834A 
  0257 0196 0200         LI   0,BUFL2      VDP buffer
       0198 1700 
  0258 019A C800         MOV  0,@H834E
       019C 044A'
  0259 019E C02E         MOV  @8(14),0     Sides
       01A0 0008 
  0260 01A2 06C0         SWPB 0
  0261 01A4 D800         MOVB 0,@H8351
       01A6 044D'

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0007
  0262 01A8 C1EE         MOV  @6(14),7     Tracks
       01AA 0006 
  0263 01AC C02E         MOV  @2(14),0     Interleave
       01AE 0002 
  0264 01B0 0A20         SLA  0,2
  0265 01B2 A02E         A    @4(14),0     Density
       01B4 0004 
  0266 01B6 C0AE         MOV  @10(14),2    Search mode?
       01B8 000A 
  0267 01BA 1307         JEQ  FMT#2        All DSR's
  0268            *
  0269            * differences in Dm2k and Du2k
  0270            * Du2k allready knows CRU address by calling FCRU
  0271            * Dm2k doesn't know CRU address and must search
  0272            *
  0273 01BC C820  FMT#1  MOV  @CRUSRC,@THSCRU      after fcru()
       01BE 0006'
       01C0 000A'
  0274 01C2 C820         MOV  @CRUSRC,@LSTCRU
       01C4 0006'
       01C6 000C'
  0275 01C8 1006         JMP  FMT#3
  0276 01CA C820  FMT#2  MOV  @FMTCRU+0,@THSCRU    search all DSR's
       01CC 000E'
       01CE 000A'
  0277 01D0 C820         MOV  @FMTCRU+2,@LSTCRU
       01D2 0010'
       01D4 000C'
  0278 01D6 06A0  FMT#3  BL   @L2BUF1
       01D8 0340'
  0279 01DA C820         MOV  @>83D0,@THSCRU
       01DC 83D0 
       01DE 000A'
  0280 01E0 C820         MOV  @>83D0,@LSTCRU
       01E2 83D0 
       01E4 000C'
  0281 01E6 045D         B    *13
  0282            
  0283            * attrib(device, name1, code) char *device, *name1; int code
  0284            * - modify file protection
  0285            *
  0286            * device:  devicenam e.g. "DSK1"
  0287            * name1 :  filename
  0288            * code  :  0 unprotect <>0 protect
  0289            *
  0290 01E8 06A0  ATTRIB BL   @GETU#6
       01EA 0060'
  0291 01EC 06A0         BL   @SRCPTH
       01EE 02B8'
  0292 01F0 0208         LI   8,MODFP      Modify file protection
       01F2 0002 
  0293 01F4 04C1         CLR  1            Code
  0294 01F6 C1EE         MOV  @2(14),7
       01F8 0002 
  0295 01FA 1301         JEQ  ATTR#1       Unprotect
  0296 01FC 0707         SETO 7            Protect
  0297 01FE C0EE  ATTR#1 MOV  @4(14),3     Name1
       0200 0004 
  0298 0202 0460         B    @L2NMBF

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0008
       0204 03DA'
  0299            
  0300            * rename(device, name1, name2) char *device, *name1, *name2;
  0301            * - rename a file
  0302            *
  0303            * device:  devicenam e.g. "DSK1"
  0304            * name1 :  old filename
  0305            * name2 :  new filename
  0306            *
  0307 0206 06A0  RENAME BL   @GETU#6
       0208 0060'
  0308 020A 06A0         BL   @SRCPTH
       020C 02B8'
  0309 020E 0208         LI   8,RNFIL      Rename File
       0210 0003 
  0310 0212 04C7         CLR  7            Code
  0311 0214 1007         JMP  REND#1
  0312            
  0313            * rendir(device, name1, name2) char *device, *name1, *name2;
  0314            * - rename directory
  0315            *
  0316            * device:  devicenam e.g. "DSK1"
  0317            * name1 :  old directoryname
  0318            * name2 :  new directoryname
  0319            *          its assumed that setpath is used to move
  0320            *          to the path were the directory must be
  0321            *          renamed
  0322            *
  0323 0216 06A0  RENDIR BL   @GETU#6
       0218 0060'
  0324 021A 06A0         BL   @SRCPTH
       021C 02B8'
  0325 021E 0208         LI   8,RNSUB      Rename directory
       0220 000A 
  0326 0222 04C7         CLR  7            Code
  0327 0224 C0EE  REND#1 MOV  @4(14),3     Old name
       0226 0004 
  0328 0228 0200         LI   0,NAME2      Name2 adres
       022A 15A0 
  0329 022C C800         MOV  0,@H8350
       022E 044C'
  0330 0230 06A0         BL   @L2NAM2
       0232 03F6'
  0331 0234 C0EE         MOV  @2(14),3     New name
       0236 0002 
  0332 0238 06A0         BL   @L2NAM1      Name1 adres
       023A 03EE'
  0333 023C 06A0         BL   @L2BUF2
       023E 0346'
  0334 0240 045D         B    *13
  0335            
  0336            * adifile(device, name1, code, sector) char *device, *name1;
  0337            * Access Direct Input File
  0338            *
  0339            * device:  devicenam e.g. "DSK1"
  0340            * name1 :  filename
  0341            * code  :  0 Read File info, >0 Read sectors
  0342            * sector:  Start sector where read begins
  0343            * returns: Number of sectors actualy read at *code

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0009
  0344            *          Number of sectors/sector number at *sector
  0345            *
  0346 0242 06A0  ADIFIL BL   @GETU#8
       0244 005A'
  0347 0246 06A0         BL   @SRCPTH
       0248 02B8'
  0348 024A 0208         LI   8,DIFIL      Direct Input File Access
       024C 0004 
  0349 024E C16E         MOV  @2(14),5     *Sector
       0250 0002 
  0350 0252 C815         MOV  *5,@>8332    Sector
       0254 8332 
  0351 0256 C1AE         MOV  @4(14),6     *code
       0258 0004 
  0352 025A C1D6         MOV  *6,7         code
  0353 025C C0EE         MOV  @6(14),3     Name1
       025E 0006 
  0354 0260 06A0         BL   @L2NAM1
       0262 03EE'
  0355 0264 0201         LI   1,BUFL2      VDP buffer
       0266 1700 
  0356 0268 0200         LI   0,>8330      Aditional info address
       026A 8330 
  0357 026C C401         MOV  1,*0
  0358 026E 06A0         BL   @L2BUF1
       0270 0340'
  0359 0272 C560         MOV  @>8332,*5    result sectors
       0274 8332 
  0360 0276 0207         LI   7,>7400      reset archive bit
       0278 7400 
  0361 027A 5807         SZCB 7,@>8334
       027C 8334 
  0362 027E D1E0         MOVB @>834D,7     result code
       0280 834D 
  0363 0282 0987         SRL  7,8
  0364 0284 C587         MOV  7,*6
  0365 0286 045D         B    *13
  0366            
  0367            * adofile(device, name1, code) char *device, *name1; int cod
  0368            * - Access Direct Output File
  0369            *
  0370            * device:  devicenam e.g. "DSK1"
  0371            * name1 :  filename
  0372            * code  :  0 Write File info, >0 Write sectors
  0373            *
  0374 0288 06A0  ADOFIL BL   @GETU#6
       028A 0060'
  0375 028C 06A0         BL   @DSTPTH
       028E 02B0'
  0376 0290 0208         LI   8,DOFIL      Direct Output File Acces
       0292 0005 
  0377 0294 C1EE         MOV  @2(14),7     Code
       0296 0002 
  0378 0298 C0EE         MOV  @4(14),3     Name1
       029A 0004 
  0379 029C 06A0         BL   @L2NAM1
       029E 03EE'
  0380 02A0 0201         LI   1,BUFL2      VDP buffer
       02A2 1700 

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0010
  0381 02A4 0200         LI   0,>8330      Aditional info address
       02A6 8330 
  0382 02A8 C401         MOV  1,*0
  0383 02AA 06A0         BL   @L2BUF1
       02AC 0340'
  0384 02AE 045D         B    *13
  0385            
  0386            * setdpath(device) char *device;
  0387            * dstpth[r1=*device]
  0388            * - Set Current Destin Pathname
  0389            * setspath(device) char *device;
  0390            * srcpth[r1=*device]
  0391            * - Set Current Source Pathname
  0392            *
  0393            * device:  devicename e.g. "DSK1.DIRECTORY."
  0394            *
  0395 02B0 C820  DSTPTH MOV  @CRUDST,@THSCRU    * asm call
       02B2 0008'
       02B4 000A'
  0396 02B6 1010         JMP  SETPAT
  0397            
  0398 02B8 C820  SRCPTH MOV  @CRUSRC,@THSCRU    * asm call
       02BA 0006'
       02BC 000A'
  0399 02BE 100C         JMP  SETPAT
  0400            
  0401 02C0 C820  SETDPA MOV  @CRUDST,@THSCRU    * c call
       02C2 0008'
       02C4 000A'
  0402 02C6 1003         JMP  SETPTH
  0403            
  0404 02C8 C820  SETSPA MOV  @CRUSRC,@THSCRU    * c call
       02CA 0006'
       02CC 000A'
  0405 02CE 06A0  SETPTH BL   @GETU#2
       02D0 006C'
  0406 02D2 06A0         BL   @SETPAT
       02D4 02D8'
  0407 02D6 045D         B    *13
  0408            
  0409 02D8 C24B  SETPAT MOV  11,9         Save return address
  0410 02DA C820         MOV  @THSCRU,@LSTCRU Only one cru address
       02DC 000A'
       02DE 000C'
  0411 02E0 0208         LI   8,SCPTH      Set Current Pathname
       02E2 0007 
  0412 02E4 04C7         CLR  7            Code
  0413 02E6 0200         LI   0,NAME1      Name1 adres
       02E8 1590 
  0414 02EA C800         MOV  0,@H834E
       02EC 044A'
  0415 02EE C0EE         MOV  @2(14),3     Name1
       02F0 0002 
  0416 02F2 C0C1         MOV  1,3          Count length
  0417 02F4 04C2         CLR  2
  0418 02F6 D131  SETP#1 MOVB *1+,4
  0419 02F8 1302         JEQ  SETP#2
  0420 02FA 0582         INC  2
  0421 02FC 10FC         JMP  SETP#1

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0011
  0422 02FE C042  SETP#2 MOV  2,1
  0423 0300 06C1         SWPB 1
  0424 0302 0420         BLWP @VSBW        Copy length
       0304 0000 
  0425 0306 0580         INC  0
  0426 0308 C043         MOV  3,1
  0427 030A 0420         BLWP @VMBW        Copy name
       030C 0152'
  0428 030E 06A0         BL   @L2BUF0
       0310 033E'
  0429 0312 C820         MOV  @PABCD2,@PABCOD Restore pabcod
       0314 0004'
       0316 0002'
  0430 0318 0459         B    *9
  0431            
  0432            * mkdir(device, name1) char *device, *name1;
  0433            * - Create Subdirectory
  0434            *
  0435            * device:  devicenam e.g. "DSK1"
  0436            * name1 :  directoryname
  0437            *          its assumed that setpath is used to move
  0438            *          to the path were the directory must be
  0439            *          created
  0440            *
  0441 031A 06A0  MKDIR  BL   @GETU#4
       031C 0066'
  0442 031E 06A0         BL   @SRCPTH
       0320 02B8'
  0443 0322 0208         LI   8,CRSUB      Create directory
       0324 0008 
  0444 0326 1006         JMP  RMDR#1
  0445            
  0446            * rmdir(device, name1) char *device, *name1;
  0447            * - Delete Subdirectory
  0448            *
  0449            * device:  devicenam e.g. "DSK1"
  0450            * name1 :  directoryname
  0451            *          its assumed that setpath is used to move
  0452            *          to the path were the directory must be
  0453            *          deleted
  0454            *
  0455 0328 06A0  RMDIR  BL   @GETU#4
       032A 0066'
  0456 032C 06A0         BL   @SRCPTH
       032E 02B8'
  0457 0330 0208         LI   8,RMSUB      Delete directory
       0332 0009 
  0458 0334 04C7  RMDR#1 CLR  7            Code
  0459 0336 C0EE         MOV  @2(14),3     Name1
       0338 0002 
  0460 033A 0460         B    @L2NMBF
       033C 03DA'
  0461            
  0462            * Base Level1 routines
  0463            *
  0464            * L2BUF0,L2BUF1,L2BUF2
  0465            *
  0466            * Input : R8 Level1 routine code
  0467            *         R7 Byte for @>834D

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0012
  0468            *         R0 Byte for @>8350
  0469            * Output: -
  0470            * Uses  : R0,R1,R2,R8
  0471            
  0472 033E 04C0  L2BUF0 CLR  0           Error code/Aditional info
  0473 0340 06C0  L2BUF1 SWPB 0
  0474 0342 D800         MOVB 0,@H8350
       0344 044C'
  0475 0346 06C7  L2BUF2 SWPB 7
  0476 0348 D807         MOVB 7,@H834D    Code/Tracks
       034A 0449'
  0477 034C D820         MOVB @GRMRA,@SAVEG
       034E 0000 
       0350 0000'
  0478 0352 1000         NOP
  0479 0354 D820         MOVB @GRMRA,@SAVEG+1
       0356 034E'
       0358 0001'
  0480 035A 0620         DEC  @SAVEG
       035C 0000'
  0481 035E A808         A    8,@PABCOD   Add L2 function code
       0360 0002'
  0482 0362 0200         LI   0,PABL2     VDP pab
       0364 1580 
  0483 0366 0201         LI   1,PABCOD    L2 code
       0368 0002'
  0484 036A 0202         LI   2,2
       036C 0002 
  0485 036E 0420         BLWP @VMBW
       0370 030C'
  0486 0372 0200  L0X    LI   0,PABL2     VDP pab
       0374 1580 
  0487 0376 C800         MOV  0,@>8356
       0378 8356 
  0488 037A 0201  L2BUF3 LI   1,H834C
       037C 0448'
  0489 037E 0202         LI   2,>834C
       0380 834C 
  0490 0382 CCB1         MOV  *1+,*2+
  0491 0384 CCB1         MOV  *1+,*2+
  0492 0386 CCB1         MOV  *1+,*2+
  0493 0388 C491         MOV  *1,*2
  0494 038A 0420         BLWP @DSRL10
       038C 0424'
  0495 038E 000A         DATA 10
  0496            **     JEQ  L4X          Error: Bad name and bad idea (05/07
  0497            **			 because Dm2k can now do setpath for DSKx
  0498            **			 and is it conform TI spec?
  0499 0390 D220         MOVB @>8350,8     Error code
       0392 8350 
  0500 0394 0988         SRL  8,8
  0501 0396 0288         CI   8,>30
       0398 0030 
  0502 039A 1313         JEQ  L4X          not altered
  0503 039C 0288         CI   8,7          SCSI
       039E 0007 
  0504 03A0 1201         JLE  L1X          yes
  0505 03A2 0958         SRL  8,5
  0506 03A4 0288  L1X    CI   8,6          Err 6,7

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0013
       03A6 0006 
  0507 03A8 1609         JNE  L2X          No
  0508 03AA 8820         C    @THSCRU,@LSTCRU
       03AC 000A'
       03AE 000C'
  0509 03B0 1305         JEQ  L2X          check one controller
  0510 03B2 C0A0         MOV  @CRULST,2    CRU address
       03B4 83D0 
  0511 03B6 0282         CI   2,>1100      TI-controller
       03B8 1100 
  0512 03BA 13DB         JEQ  L0X          Yes
  0513 03BC C808  L2X    MOV  8,@ERRNO
       03BE 0072'
  0514 03C0 1301         JEQ  L7X
  0515 03C2 0708  L4X    SETO 8            Error
  0516 03C4 D820  L7X    MOVB @SAVEG,@GRMWA
       03C6 0000'
       03C8 0000 
  0517 03CA 1000         NOP
  0518 03CC D820         MOVB @SAVEG+1,@GRMWA
       03CE 0001'
       03D0 03C8'
  0519 03D2 C208         MOV  8,8
  0520 03D4 1601         JNE  L8X
  0521 03D6 045B         B    *11
  0522 03D8 045D  L8X    B    *13
  0523            
  0524            * L2NMBF- Call L2NAM1 and L2BUF0
  0525            *
  0526            * Input : R3 address of name
  0527            *         R8 Level1 routine code
  0528            *         R7 Byte for @>834D
  0529            *         R0 Byte for @>8350
  0530            * Output: -
  0531            * Uses  : R0,R1,R2,R3,R4,R8
  0532            *
  0533 03DA 06A0  L2NMBF BL   @L2NAM1
       03DC 03EE'
  0534 03DE 06A0         BL   @L2BUF0
       03E0 033E'
  0535 03E2 045D         B    *13
  0536            
  0537            * L2NAM1- Copy name to vdpbuf
  0538            * L2NAM2-
  0539            * Input: R0 VDPadres
  0540            *        R3 address of name
  0541            * Uses:  R1,R2,R3,R4
  0542            *
  0543 03E4   20  L2SPAC TEXT '          '
  0544 03EE 0200  L2NAM1 LI   0,NAME1      Name1 adres
       03F0 1590 
  0545 03F2 C800         MOV  0,@H834E
       03F4 044A'
  0546 03F6 0201  L2NAM2 LI   1,L2SPAC
       03F8 03E4'
  0547 03FA 0202         LI   2,10
       03FC 000A 
  0548 03FE 0420         BLWP @VMBW
       0400 0370'

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0014
  0549 0402 C043         MOV  3,1          Count length
  0550 0404 04C2         CLR  2
  0551 0406 D133  L2NAM3 MOVB *3+,4
  0552 0408 1302         JEQ  L2NAM4
  0553 040A 0582         INC  2
  0554 040C 10FC         JMP  L2NAM3
  0555 040E C082  L2NAM4 MOV  2,2          No name?
  0556 0410 1303         JEQ  L2NAM6       Yes
  0557 0412 0420         BLWP @VMBW        Copy name
       0414 0400'
  0558 0416 045B  L2NAM5 RT
  0559            
  0560 0418 0208  L2NAM6 LI   8,7          Filename error
       041A 0007 
  0561 041C C808         MOV  8,@ERRNO
       041E 03BE'
  0562 0420 0708         SETO 8
  0563 0422 045D         B    *13
  0564            
  0565            * T-SHELL SOURCE CODE BY TRAVIS WATFORD
  0566            * excerpt taken by B. Harrison - MODIFIED
  0567            *                  F.G.Kaal - MODIFIED
  0568            *----------------------------------------
  0569            *  Device service routine for DATA >000A
  0570            *
  0571 0424 0428' DSRL10 DATA DSRWS,DSR#10
       0426 0452'
  0572 0428       DSRWS  BSS  32
  0573      0432' DSRWS5 EQU  DSRWS+10
  0574            
  0575 0448   00  H834C  BYTE 0   Buffer for ram locations
  0576 0449   00  H834D  BYTE 0
  0577 044A   00  H834E  BYTE 0
  0578 044B   00  H834F  BYTE 0
  0579 044C   00  H8350  BYTE 0
  0580 044D   00  H8351  BYTE 0
  0581 044E   00  H8352  BYTE 0
  0582 044F   00  H8353  BYTE 0
  0583            
  0584      8356  NPNTR  EQU  >8356
  0585      8354  NLEN   EQU  >8354
  0586      83D0  CRULST EQU  >83D0
  0587      83D2  SAVADD EQU  >83D2
  0588      8C02  VDPWA  EQU  >8C02
  0589      8800  VDPRD  EQU  >8800
  0590 0450   20  H20    BYTE >20
  0591 0451   AA  HAA    BYTE >AA
  0592                   EVEN
  0593 0452 C17E  DSR#10 MOV  *R14+,R5     Get DSR offset (>A)
  0594 0454 53E0         SZCB @H20,R15
       0456 0450'
  0595 0458 0204         LI   R4,1         Pabcod is >01xx
       045A 0001 
  0596 045C C804  DSR2   MOV  R4,@NLEN     Save name length
       045E 8354 
  0597 0460 0584         INC  R4
  0598 0462 A804         A    R4,@NPNTR    Adjust name pointer
       0464 8356 
  0599 0466 02E0         LWPI GPLWS

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0015
       0468 0000 
  0600 046A 04C1         CLR  R1           Dsr version etc
  0601 046C C320         MOV  @THSCRU,R12  This Cru
       046E 000A'
  0602            
  0603 0470 C80C  CRUOK  MOV  R12,@CRULST  Save cru address
       0472 83D0 
  0604 0474 1D00         SBO  0            Card on
  0605 0476 0202         LI   R2,>4000     See if a card is present
       0478 4000 
  0606 047A 9812         CB   *R2,@HAA
       047C 0451'
  0607 047E 1618         JNE  DSR8A
  0608 0480 A0A0  DSR4B  A    @DSRWS5,R2   Add DSR offset
       0482 0432'
  0609 0484 1002         JMP  DSR5
  0610 0486 C0A0  DSR4   MOV  @SAVADD,R2   Get DSR routine address
       0488 83D2 
  0611 048A C092  DSR5   MOV  *R2,R2       Any routines?
  0612 048C 1311         JEQ  DSR8A        No
  0613 048E C802         MOV  R2,@SAVADD   Save link to next DSR routine addre
       0490 83D2 
  0614 0492 05C2         INCT R2
  0615 0494 C272         MOV  *R2+,R9      Get DSR routine address
  0616 0496 0205         LI   R5,PABCOD    The DSR code
       0498 0002'
  0617 049A 9CB5         CB   *R5+,*R2+    Name length matches
  0618 049C 16F4         JNE  DSR4         No
  0619 049E 9CB5         CB   *R5+,*R2+    DSR code matches
  0620 04A0 16F2         JNE  DSR4         No
  0621 04A2 0581  DSR7   INC  R1           Next version
  0622 04A4 0699         BL   *R9          Call DSR routine
  0623 04A6 10EF         JMP  DSR4         Error? Try next
  0624 04A8 1E00         SBZ  0            Card off
  0625 04AA 02E0         LWPI DSRWS
       04AC 0428'
  0626 04AE 0380         RTWP
  0627            
  0628 04B0 1E00  DSR8A  SBZ  0            Card off
  0629 04B2 022C         AI   R12,>0100    Next
       04B4 0100 
  0630 04B6 880C         C    R12,@LSTCRU
       04B8 000C'
  0631 04BA 1ADA         JL   CRUOK
  0632 04BC 02E0  DSR8   LWPI DSRWS
       04BE 0428'
  0633 04C0 04C1  DSR9   CLR  R1           Error 0=bad name
  0634 04C2 D741         MOVB R1,*R13      Error code to R0 of calling program
  0635 04C4 F3E0         SOCB @H20,R15     Set equal bit for error
       04C6 0450'
  0636 04C8 0380         RTWP
  0637                   END

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0016
  D ADIFIL  0242    D ADOFIL  0288    ' ATTR#1  01FE    D ATTRIB  01E8  
  ' BF#CPU  00C9      BF$CPU  0080      BUFAL   0006    D BUFL2   1700  
    BUFRW   1600    E CNULL   0086      CRSUB   0008    D CRUDST  0008  
  D CRULST  83D0    ' CRUOK   0470    D CRUSRC  0006    ' DEVL2C  0036  
  ' DEVNAM  002A      DIFIL   0004    ' DN#SID  00C8      DOFIL   0005  
  ' DSR#10  0452    ' DSR2    045C    ' DSR4    0486    ' DSR4B   0480  
  ' DSR5    048A    ' DSR7    04A2    ' DSR8    04BC    ' DSR8A   04B0  
  ' DSR9    04C0    ' DSRL10  0424    ' DSRWS   0428    ' DSRWS5  0432  
  ' DSTPTH  02B0    E ERRNO   041E    D FILES   0170    ' FMT#1   01BC  
  ' FMT#2   01CA    ' FMT#3   01D6    ' FMTCRU  000E    D FMTDSK  0188  
    FORFD   0001    D GETU#1  0070    D GETU#2  006C    D GETU#4  0066  
  D GETU#6  0060    ' GETU#8  005A    ' GETU#C  0054    ' GETU19  00AC  
  ' GETUAZ  00B4    ' GETUER  00B2    ' GETUEX  00B8    ' GETUFN  0090  
  ' GETUN0  007C    ' GETUN1  0080    ' GETUN2  0084    ' GETUQT  00C4  
  E GPLWS   0468    E GRMRA   0356    E GRMWA   03D0    ' H20     0450  
  D H834C   0448    D H834D   0449    D H834E   044A    ' H834F   044B  
  D H8350   044C    ' H8351   044D    D H8352   044E    ' H8353   044F  
  ' HAA     0451    ' L0X     0372    ' L1X     03A4    D L2BUF0  033E  
  ' L2BUF1  0340    D L2BUF2  0346    D L2BUF3  037A    ' L2NAM1  03EE  
  ' L2NAM2  03F6    ' L2NAM3  0406    ' L2NAM4  040E    ' L2NAM5  0416  
  ' L2NAM6  0418    ' L2NMBF  03DA    ' L2SPAC  03E4    ' L2X     03BC  
  ' L4X     03C2    ' L7X     03C4    ' L8X     03D8    D LSTCRU  000C  
  D MKDIR   031A      MODFP   0002      NAME1   1590      NAME2   15A0  
    NLEN    8354      NPNTR   8356    ' P#DSK   0012    ' P#HDS   0016  
  ' P#HDX   0026    ' P#IDE   0022    ' P#SCS   001E    ' P#WDS   001A  
  ' PABCD2  0004    D PABCOD  0002    D PABL2   1580      R0      0000  
    R1      0001      R10     000A      R11     000B      R12     000C  
    R13     000D      R14     000E      R15     000F      R2      0002  
    R3      0003      R4      0004      R5      0005      R6      0006  
    R7      0007      R8      0008      R9      0009    ' READS1  00FE  
  ' READS2  0102    D READSE  00EE    ' READSX  0132    D RENAME  0206  
  ' REND#1  0224    D RENDIR  0216    D RMDIR   0328    ' RMDR#1  0334  
    RMSUB   0009      RNFIL   0003      RNSUB   000A      SAVADD  83D2  
  D SAVEG   0000    ' SC#SCS  00CA      SCPTH   0007      SE$124  0020  
    SE$248  0030      SE$256  0000      SE$512  0010      SECRW   0000  
  D SETDPA  02C0    D SETDST  004C    ' SETP#1  02F6    ' SETP#2  02FE  
  ' SETPAT  02D8    ' SETPTH  02CE    D SETSPA  02C8    D SETSRC  0044  
  ' SRCPTH  02B8    ' T#SCS   00CC    ' T#SCS#  00EC    D THSCRU  000A  
    VDPRD   8800      VDPWA   8C02    E VMBR    0130    E VMBW    0414  
  E VSBR    0000    E VSBW    0304    D WRITES  0134    ' WRITS1  0144  
  ' WRITS2  0154  
  0000 ERRORS

 Xa99 Cross Assembler
L2FIO FUNCTIONS 09/03/2007                                   PAGE 0017
  SEGMENT RORG     SIZE 01226 (>04CA) BYTES
