
 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0001
  0001            * L3FioG
  0002            *
  0003            * Written by:
  0004            *
  0005            *  Frederik G. Kaal
  0006            *  De Dadelboom 81
  0007            *  1911 KK Uitgeest
  0008            *  The Netherlands
  0009            *
  0010            * These are the Level 3 routines for file and floppy access 
  0011            * sector level for the Myarc 9640 (Geneve)
  0012            *
  0013            * All routines, except fopen, returns 0 if no error occured 
  0014            * an error occured.
  0015            * The error code is left in errno. A result of -1 with errno
  0016            * bad device name.
  0017            
  0018                   DEF FOPEN,FCLOSE,FREAD,FWRITE
  0019                   DEF FSTAT,FEOF,FSEEK,FDEL,FLOAD,FSAVE,MKDIR
  0020                   DEF ATTRIB,RENAME,RENDIR,ADIFIL,ADOFIL
  0021                   REF ERRNO,CNULL
  0022            
  0023            *BUFRW  BSS  256          Buffer Read/Write
  0024            *BUFLSD BSS              Buffer Load/Save/Delete
  0025 0000       PABRW1 BSS  50           Pab Read/Write
  0026 0032       PABRW2 BSS  50
  0027 0064       PABRW3 BSS  50
  0028 0096       PABRW4 BSS  50
  0029 00C8       PABLSD BSS  50           Pab Load/Save/Delete
  0030      0032  PABLEN EQU  50
  0031      0005  NUMFIL EQU   5
  0032            
  0033      1F00  CLREFL EQU  >1F00
  0034      1100  FIXREL EQU  >1100
  0035            
  0036 00FA 0000  SAVEG  DATA 0
  0037 00FC 00C8' FILALL DATA PABLSD,PABRW1,PABRW2,PABRW3,PABRW4
       00FE 0000'
       0100 0032'
       0102 0064'
       0104 0096'
  0038 0106 00C8' FILSTK DATA PABLSD,0,0,0,0
       0108 0000 
       010A 0000 
       010C 0000 
       010E 0000 
  0039            
  0040 0110 0008  IOXOP  DATA 8
  0041            
  0042      0000  PABOPC EQU  0            Opcode
  0043      0001  PABMOD EQU  1            Mode
  0044      0002  PABERR EQU  2            Error
  0045      0003  PABBUF EQU  3            Buffer (3 bytes)
  0046      0006  PABREC EQU  6            Record # (2 bytes)
  0047      0008  PABLRL EQU  8            Log. Record length (2 bytes)
  0048      000A  PABMEM EQU  10           Memory flag 0=cpu >0=vdp
  0049      000B  PABCNT EQU  11           Byte count (3 bytes)
  0050      000E  PABSTA EQU  14           Status
  0051      000F  PABFNL EQU  15           Filename length

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0002
  0052      0010  PABFNM EQU  16           Filename
  0053            
  0054            * getpab() - Get address  desired PAB
  0055            *            Returns to calling program
  0056            *
  0057            * Input : File pointer as 1st, 2nd or 3rd argument
  0058            * Output: R1 Pointer of PAB in CPU ram
  0059            *         R4 Pointer to PAB adres in filstk
  0060            * Uses  : R0,R1,R2,R4
  0061            *
  0062 0112 C12E  GTPAB2 MOV  @2(14),4     Fp 1st
       0114 0002 
  0063 0116 1005         JMP  GTPAB0
  0064 0118 C12E  GTPAB4 MOV  @4(14),4     Fp 2nd
       011A 0004 
  0065 011C 1002         JMP  GTPAB0
  0066 011E C12E  GTPAB6 MOV  @6(14),4     Fp 3rd
       0120 0006 
  0067 0122 04E0  GTPAB0 CLR  @ERRNO       Result
       0124 0000 
  0068 0126 1308         JEQ  GTPB#X       Error
  0069 0128 0284         CI   4,NUMFIL
       012A 0005 
  0070 012C 1405         JHE  GTPB#X       Error
  0071 012E 0A14         SLA  4,1
  0072 0130 0224         AI   4,FILSTK     &filstk[fp]
       0132 0106'
  0073 0134 C054  GETPAB MOV  *4,1         filstk[fp]
  0074 0136 045B         B    *11          Ok
  0075 0138 0708  GTPB#X SETO 8            Error
  0076 013A 045D         B    *13
  0077            
  0078            * getfp  - find free file allocation buffer
  0079            *
  0080            * Input : R14 pointer to arg-list char *name, int access, si
  0081            * Output: PAB build
  0082            *         R1 pab address
  0083            *         R4 pointer free pfilstk
  0084            *         R5 pointer free pfilall
  0085            *         R7 fp
  0086            * Uses  : R1,2,3,4,5,7,10,11
  0087            *
  0088 013C C24B  GETFP  MOV  11,9         save return
  0089 013E 0207         LI   7,1          fp=1
       0140 0001 
  0090 0142 0204         LI   4,FILSTK+2   &filstk[1]
       0144 0108'
  0091 0146 0205         LI   5,FILALL+2   &filall[1]
       0148 00FE'
  0092 014A 0287  GETFP1 CI   7,NUMFIL     fp<numfil?
       014C 0005 
  0093 014E 1A04         JL   GETFP2       Yes!
  0094 0150 0200         LI   0,4          Out of bufer space
       0152 0004 
  0095 0154 0460         B    @ERROR
       0156 03D8'
  0096            
  0097 0158 C014  GETFP2 MOV  *4,0         *pfp==0?
  0098 015A 1304         JEQ  GETFP3       yes!

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0003
  0099 015C 0587         INC  7            fp++
  0100 015E 05C4         INCT 4            pfilstk++
  0101 0160 05C5         INCT 5            pfilall++
  0102 0162 10F3         JMP  GETFP1
  0103 0164 C515  GETFP3 MOV  *5,*4        filstk[fp]=filall[fp]
  0104 0166 C055         MOV  *5,1         Pab adres
  0105 0168 06A0         BL   @LNKPB6
       016A 038C'
  0106 016C C0AE         MOV  @4(14),2     Access code
       016E 0004 
  0107 0170 06C2         SWPB 2
  0108 0172 D842         MOVB 2,@PABMOD(1)
       0174 0001 
  0109 0176 C0AE         MOV  @2(14),2     Record length
       0178 0002 
  0110 017A C842         MOV  2,@PABLRL(1)
       017C 0008 
  0111 017E 0459         B    *9
  0112            
  0113            * fopen(name,access,size) char *name; int access,size;
  0114            *
  0115 0180 06A0  FOPEN  BL   @GETFP
       0182 013C'
  0116 0184 04C0         CLR  0            Open
  0117 0186 06A0         BL   @LNKDSR
       0188 03B4'
  0118 018A 1302         JEQ  FOPENX       Ok
  0119 018C 04D4         CLR  *4           *pfp=0
  0120 018E 045D         B    *13
  0121 0190 C0A1  FOPENX MOV  @PABLRL(1),2
       0192 0008 
  0122 0194 C802         MOV  2,@ERRNO
       0196 0124'
  0123 0198 C207         MOV  7,8          return fp
  0124 019A 045D         B    *13
  0125            
  0126            * fclose(fp) int fp;
  0127            *
  0128 019C 06A0  FCLOSE BL   @GTPAB2
       019E 0112'
  0129 01A0 0200         LI   0,>0100      Close
       01A2 0100 
  0130 01A4 06A0         BL   @LNKDSR
       01A6 03B4'
  0131 01A8 04D4         CLR  *4           filstk[fp]=0
  0132 01AA 1305         JEQ  FCLS#X       No
  0133 01AC 0280         CI   0,7          File error
       01AE 0007 
  0134 01B0 1302         JEQ  FCLS#X       Yes
  0135 01B2 0708         SETO 8            Error!
  0136 01B4 045D         B    *13
  0137 01B6 04C8  FCLS#X CLR  8
  0138 01B8 045D         B    *13
  0139            
  0140            * fread(fp,buff,size) int fp; char buff[]; int *size;
  0141            *
  0142 01BA 06A0  FREAD  BL   @GTPAB6
       01BC 011E'
  0143 01BE C86E         MOV  @4(14),@PABBUF+1(1)

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0004
       01C0 0004 
       01C2 0004 
  0144 01C4 0200  FREAD2 LI   0,>0200      Read
       01C6 0200 
  0145 01C8 06A0         BL   @LNKDSR
       01CA 03B4'
  0146 01CC 160A         JNE  FREAD4       Error
  0147 01CE C161         MOV  @PABBUF+1(1),5 Buffer address
       01D0 0004 
  0148 01D2 C0A1         MOV  @PABCNT+1(1),2 Bytecount
       01D4 000C 
  0149 01D6 A142         A    2,5          End of buffer
  0150 01D8 04C0         CLR  0
  0151 01DA D540         MOVB 0,*5         Terminate with null
  0152 01DC C02E         MOV  @2(14),0     *size=bytecount
       01DE 0002 
  0153 01E0 C402         MOV  2,*0
  0154 01E2 045D  FREAD4 B    *13
  0155            
  0156            * fwrite(fp,buff,size) int fp; char buff[]; int size;
  0157            *
  0158 01E4 06A0  FWRITE BL   @GTPAB6
       01E6 011E'
  0159 01E8 C86E         MOV  @4(14),@PABBUF+1(1)
       01EA 0004 
       01EC 0004 
  0160 01EE C02E         MOV  @4(14),0     &buf
       01F0 0004 
  0161 01F2 C840         MOV  0,@PABBUF+1(1)
       01F4 0004 
  0162 01F6 C0AE  FWRIT2 MOV  @2(14),2     size
       01F8 0002 
  0163 01FA 1605         JNE  FWRIT4
  0164 01FC 04C2         CLR  2            len
  0165 01FE D0F0  FWRIT3 MOVB *0+,3        \0?
  0166 0200 1302         JEQ  FWRIT4       Yes
  0167 0202 0582         INC  2
  0168 0204 10FC         JMP  FWRIT3
  0169 0206 C842  FWRIT4 MOV  2,@PABCNT+1(1)
       0208 000C 
  0170 020A 0200  FWRIT5 LI   0,>0300      Write
       020C 0300 
  0171 020E 06A0         BL   @LNKDSR
       0210 03B4'
  0172 0212 045D         B    *13
  0173            
  0174            * fseek(fp,rec) int fp;
  0175            *
  0176 0214 06A0  FSEEK  BL   @GTPAB4
       0216 0118'
  0177 0218 C86E         MOV  @2(14),@PABREC(1) rec
       021A 0002 
       021C 0006 
  0178 021E 0200         LI   0,>0400     Rewind
       0220 0400 
  0179 0222 06A0         BL   @LNKDSR
       0224 03B4'
  0180 0226 045D  FSEEKX B    *13
  0181            

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0005
  0182            * attrib(name) char *name;
  0183            *
  0184 0228 0201  FSTAT  LI   1,PABLSD
       022A 00C8'
  0185 022C 06A0         BL   @LNKPB2
       022E 0380'
  0186 0230 0200         LI   0,>0900     Status
       0232 0900 
  0187 0234 06A0         BL   @LNKDS0
       0236 03BA'
  0188 0238 1603         JNE  FSTAT2
  0189 023A D221         MOVB @PABSTA(1),8
       023C 000E 
  0190 023E 06C8         SWPB 8
  0191 0240 045D  FSTAT2 B    *13
  0192            
  0193            * rename(patholdname, newname) char *patholdname; char *newn
  0194            * feof(fp) int fp;
  0195            *
  0196            * Returns -1 : Error
  0197            *          0 : Not EOF
  0198            *          1 : Eof
  0199            *
  0200 0242 06A0  FEOF   BL   @GTPAB2
       0244 0112'
  0201 0246 0200         LI   0,>0900
       0248 0900 
  0202 024A 06A0         BL   @LNKDSR
       024C 03B4'
  0203 024E 1605         JNE  FEOF2        Error!
  0204 0250 D221         MOVB @PABSTA(1),8
       0252 000E 
  0205 0254 06C8         SWPB 8
  0206 0256 0248         ANDI 8,1          Eof?
       0258 0001 
  0207 025A 045D  FEOF2  B    *13
  0208            
  0209            * fdel(name) char *name;
  0210            *
  0211 025C 0201  FDEL   LI   1,PABLSD
       025E 00C8'
  0212 0260 06A0         BL   @LNKPB2
       0262 0380'
  0213 0264 0200         LI   0,>0700
       0266 0700 
  0214 0268 06A0         BL   @LNKDSR
       026A 03B4'
  0215 026C 045D         B    *13
  0216            
  0217            * fload(name,buff,size) char *name; char *buff, int *size;
  0218            *
  0219 026E 0201  FLOAD  LI   1,PABLSD
       0270 00C8'
  0220 0272 06A0         BL   @LNKPB6
       0274 038C'
  0221 0276 C86E         MOV  @4(14),@PABBUF+1(1) &buff
       0278 0004 
       027A 0004 
  0222 027C C16E         MOV  @2(14),5         *size

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0006
       027E 0002 
  0223 0280 C855         MOV  *5,@PABCNT+1(1)
       0282 000C 
  0224 0284 0200         LI   0,>0500          Load
       0286 0500 
  0225 0288 06A0         BL   @LNKDSR
       028A 03B4'
  0226 028C C561         MOV  @PABLRL(1),*5    Loaded size
       028E 0008 
  0227 0290 045D         B    *13
  0228            
  0229            * fsave(name,buff,size) char *name; char *buff; int size;
  0230            *
  0231 0292 0201  FSAVE  LI   1,PABLSD
       0294 00C8'
  0232 0296 06A0         BL   @LNKPB6
       0298 038C'
  0233 029A C86E         MOV  @4(14),@PABBUF+1(1) &buff
       029C 0004 
       029E 0004 
  0234 02A0 C86E         MOV  @2(14),@PABCNT+1(1) size
       02A2 0002 
       02A4 000C 
  0235 02A6 0200         LI   0,>0600      Save
       02A8 0600 
  0236 02AA 06A0         BL   @LNKDSR
       02AC 03B4'
  0237 02AE 045D         B    *13
  0238            
  0239            * mkdir(name) char *name;
  0240            *
  0241 02B0 0201  MKDIR  LI   1,PABLSD
       02B2 00C8'
  0242 02B4 06A0         BL   @LNKPB2
       02B6 0380'
  0243 02B8 0200         LI   0,10
       02BA 000A 
  0244 02BC C840         MOV  0,@PABBUF+1(1) &buff better be save
       02BE 0004 
  0245 02C0 C840         MOV  0,@PABCNT+1(1) size  than sorry
       02C2 000C 
  0246 02C4 0200         LI   0,>0600      Save=mkdir
       02C6 0600 
  0247 02C8 06A0         BL   @LNKDSR
       02CA 03B4'
  0248 02CC 045D         B    *13
  0249            
  0250            * attrib(name, code) char *name; int code;
  0251            *
  0252 02CE 0201  ATTRIB LI   1,PABLSD
       02D0 00C8'
  0253 02D2 06A0         BL   @LNKPB4
       02D4 0386'
  0254 02D6 C0AE         MOV  @2(14),2     Flag
       02D8 0002 
  0255 02DA 06C2         SWPB 2
  0256 02DC D842         MOVB 2,@PABMOD(1)
       02DE 0001 
  0257 02E0 0200         LI   0,>0C00     Protect

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0007
       02E2 0C00 
  0258 02E4 06A0         BL   @LNKDS0
       02E6 03BA'
  0259 02E8 045D         B    *13
  0260            
  0261            * rename(patholdname, newname) char *patholdname; char *newn
  0262            *
  0263 02EA       NEWNAM BSS  10
  0264            RENDIR
  0265 02F4 0201  RENAME LI   1,PABLSD
       02F6 00C8'
  0266 02F8 06A0         BL   @LNKPB4
       02FA 0386'
  0267 02FC C02E         MOV  @2(14),0    newname
       02FE 0002 
  0268 0300 0203         LI   3,NEWNAM    Newname address
       0302 02EA'
  0269 0304 C843         MOV  3,@PABBUF+1(1)
       0306 0004 
  0270 0308 0202         LI   2,10        Max 10 chars
       030A 000A 
  0271 030C D4F0  RENAM1 MOVB *0+,*3
  0272 030E 1304         JEQ  RENAM2
  0273 0310 0583         INC  3
  0274 0312 0602         DEC  2
  0275 0314 130D         JEQ  RENAM5
  0276 0316 10FA         JMP  RENAM1
  0277 0318 0282  RENAM2 CI   2,10
       031A 000A 
  0278 031C 1A04         JL   RENAM3
  0279 031E 0200         LI   0,7         file error
       0320 0007 
  0280 0322 0460         B    @ERROR
       0324 03D8'
  0281 0326 0200  RENAM3 LI   0,>2000     space
       0328 2000 
  0282 032A DCC0  RENAM4 MOVB 0,*3+
  0283 032C 0602         DEC  2
  0284 032E 16FD         JNE  RENAM4
  0285 0330 0200  RENAM5 LI   0,>0D00     Rename
       0332 0D00 
  0286 0334 06A0         BL   @LNKDSR
       0336 03B4'
  0287 0338 045D         B    *13
  0288            
  0289            * adifile(name, buff, code, nsector)
  0290            * char *name; char *buff; int *code; int *nsector;
  0291            *
  0292 033A 0208  ADIFIL LI   8,>0A00
       033C 0A00 
  0293 033E C02E         MOV  @6(14),0        &buf
       0340 0006 
  0294 0342 0202         LI   2,20
       0344 0014 
  0295 0346 DC02  ADICLR MOVB 2,*0+
  0296 0348 0602         DEC  2
  0297 034A 16FD         JNE  ADICLR
  0298 034C 1002         JMP  ADIADO
  0299            

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0008
  0300            * adofile(name, buff, code, nsector)
  0301            * char *name; char *buff; int *code; int *nsector;
  0302            *
  0303 034E 0208  ADOFIL LI  8,>0B00
       0350 0B00 
  0304 0352 0201  ADIADO LI  1,PABLSD
       0354 00C8'
  0305 0356 06A0         BL  @LNKPB8
       0358 0392'
  0306 035A C86E         MOV  @6(14),@PABBUF+1(1) &buff
       035C 0006 
       035E 0004 
  0307 0360 C16E         MOV  @4(14),5         code
       0362 0004 
  0308 0364 C855         MOV  *5,@PABCNT+1(1)
       0366 000C 
  0309 0368 C1AE         MOV  @2(14),6         nsector
       036A 0002 
  0310 036C C856         MOV  *6,@PABREC(1)
       036E 0006 
  0311 0370 C008         MOV  8,0
  0312 0372 06A0         BL   @LNKDSR
       0374 03B4'
  0313 0376 C561         MOV  @PABCNT+1(1),*5  sectors not read/write due to e
       0378 000C 
  0314 037A C5A1         MOV  @PABREC(1),*6    last sector read/write +1
       037C 0006 
  0315 037E 045D         B    *13
  0316            
  0317            * lnkpab - put default values in pab
  0318            *
  0319            * Input : R1  PAB address
  0320            *         R14 stack pointer to arguments
  0321            * Output:
  0322            * Uses  : R0, R2, R3
  0323            *
  0324 0380 C0EE  LNKPB2 MOV  @2(14),3     &name 1st arg
       0382 0002 
  0325 0384 1008         JMP  LNKPB0
  0326 0386 C0EE  LNKPB4 MOV  @4(14),3     &name 2nd arg
       0388 0004 
  0327 038A 1005         JMP  LNKPB0
  0328 038C C0EE  LNKPB6 MOV  @6(14),3     &name 3rd arg
       038E 0006 
  0329 0390 1002         JMP  LNKPB0
  0330 0392 C0EE  LNKPB8 MOV  @8(14),3     &name 4th arg
       0394 0008 
  0331 0396 C001  LNKPB0 MOV  1,0          PAB
  0332 0398 0202         LI   2,8
       039A 0008 
  0333 039C 04F0  LNKPBC CLR  *0+          Clear PAB
  0334 039E 0602         DEC  2
  0335 03A0 16FD         JNE  LNKPBC
  0336 03A2 04C2         CLR  2            Move name
  0337 03A4 DC33  LNKPBD MOVB *3+,*0+
  0338 03A6 1302         JEQ  LNKPBE
  0339 03A8 0582         INC  2
  0340 03AA 10FC         JMP  LNKPBD
  0341 03AC 06C2  LNKPBE SWPB 2

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0009
  0342 03AE D842         MOVB 2,@PABFNL(1) Name length
       03B0 000F 
  0343 03B2 045B         RT
  0344            
  0345            * linkdsr(fp) int fp;
  0346            *
  0347            * Call DSR routine
  0348            *
  0349            * Input : R1 PAB address
  0350            * Output: R0 PAB error code
  0351            * Uses  : R0, R8, R9, R11
  0352            *
  0353 03B4 04C8  LNKDSR CLR  8
  0354 03B6 D848         MOVB 8,@PABERR(1)
       03B8 0002 
  0355 03BA 04C8  LNKDS0 CLR 8
  0356 03BC D840         MOVB 0,@PABOPC(1) Opcode
       03BE 0000 
  0357 03C0 C001         MOV  1,0
  0358 03C2 2C20         XOP  @IOXOP,0
       03C4 0110'
  0359 03C6 D021         MOVB @PABERR(1),0
       03C8 0002 
  0360 03CA 09D0         SRL  0,13         Error code
  0361 03CC C800         MOV  0,@ERRNO
       03CE 0196'
  0362 03D0 1301         JEQ  LNKDS1
  0363 03D2 0708         SETO 8
  0364 03D4 C208  LNKDS1 MOV  8,8
  0365 03D6 045B         B    *11
  0366            
  0367            * ERROR - Set error code in ERRNO
  0368            *
  0369            * Input : R0 error code
  0370            * Output: R8 -1
  0371            * Uses  : R8
  0372            
  0373 03D8 C800  ERROR  MOV  0,@ERRNO
       03DA 03CE'
  0374 03DC 0708         SETO 8
  0375 03DE 045D         B    *13
  0376            
  0377                   END

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0010
  ' ADIADO  0352    ' ADICLR  0346    D ADIFIL  033A    D ADOFIL  034E  
  D ATTRIB  02CE      CLREFL  1F00    E CNULL   0000    E ERRNO   03DA  
  ' ERROR   03D8    D FCLOSE  019C    ' FCLS#X  01B6    D FDEL    025C  
  D FEOF    0242    ' FEOF2   025A    ' FILALL  00FC    ' FILSTK  0106  
    FIXREL  1100    D FLOAD   026E    D FOPEN   0180    ' FOPENX  0190  
  D FREAD   01BA    ' FREAD2  01C4    ' FREAD4  01E2    D FSAVE   0292  
  D FSEEK   0214    ' FSEEKX  0226    D FSTAT   0228    ' FSTAT2  0240  
  ' FWRIT2  01F6    ' FWRIT3  01FE    ' FWRIT4  0206    ' FWRIT5  020A  
  D FWRITE  01E4    ' GETFP   013C    ' GETFP1  014A    ' GETFP2  0158  
  ' GETFP3  0164    ' GETPAB  0134    ' GTPAB0  0122    ' GTPAB2  0112  
  ' GTPAB4  0118    ' GTPAB6  011E    ' GTPB#X  0138    ' IOXOP   0110  
  ' LNKDS0  03BA    ' LNKDS1  03D4    ' LNKDSR  03B4    ' LNKPB0  0396  
  ' LNKPB2  0380    ' LNKPB4  0386    ' LNKPB6  038C    ' LNKPB8  0392  
  ' LNKPBC  039C    ' LNKPBD  03A4    ' LNKPBE  03AC    D MKDIR   02B0  
  ' NEWNAM  02EA      NUMFIL  0005      PABBUF  0003      PABCNT  000B  
    PABERR  0002      PABFNL  000F      PABFNM  0010      PABLEN  0032  
    PABLRL  0008    ' PABLSD  00C8      PABMEM  000A      PABMOD  0001  
    PABOPC  0000      PABREC  0006    ' PABRW1  0000    ' PABRW2  0032  
  ' PABRW3  0064    ' PABRW4  0096      PABSTA  000E      R0      0000  
    R1      0001      R10     000A      R11     000B      R12     000C  
    R13     000D      R14     000E      R15     000F      R2      0002  
    R3      0003      R4      0004      R5      0005      R6      0006  
    R7      0007      R8      0008      R9      0009    ' RENAM1  030C  
  ' RENAM2  0318    ' RENAM3  0326    ' RENAM4  032A    ' RENAM5  0330  
  D RENAME  02F4    D RENDIR  02F4    ' SAVEG   00FA  
  0000 ERRORS

 Xa99 Cross Assembler
VERSION 1.2/A                                                PAGE 0011
  SEGMENT RORG     SIZE 00992 (>03E0) BYTES
